## org.gnu.gdk
Class Drawable

    java.lang.Object
      org.gnu.glib.GObject
          org.gnu.gdk.Drawable

Direct Known Subclasses:
  Bitmap, Pixmap, Window

public class Drawable
extends GObject

Provides support for drawing points, lines, arcs, and text onto what we call 'drawables'. Drawables, as the name suggests, are things which support drawing onto them and are either org.gnu.gdk.Window or org.gnu.gdk.Pixmap objects.

Field Summary

Fields inherited from class org.gnu.glib.GObject
`eventsInitialized`

Constructor Summary
`Drawable(Handle handle)`

Method Summary
`void` `drawArc(boolean filled, int x, int y, int width, int height, int angle1, int angle2)` Draws an arc or a filled 'pie slice'.
`void` `drawArc(GC gc, boolean filled, int x, int y, int width, int height, int angle1, int angle2)` Draws an arc or a filled 'pie slice'.
`void` `drawDrawable(Drawable src, int xsrc, int ysrc, int xdest, int ydest, int width, int height)` Convience method that copies the width x height region of the Drawable at coordinates (xsrc,ysrc) to coordinates (xdest,ydest) using the default GC.
`void` `drawDrawable(GC gc, Drawable src, int xsrc, int ysrc, int xdest, int ydest, int width, int height)` Copies the width x height region of the Drawable at coordinates (xsrc,ysrc) to coordinates (xdest,ydest).
`void` `drawGlyphs(Font font, int x, int y, GlyphString glyphs)` This is a low-level function.
`void` `drawGlyphs(GC gc, Font font, int x, int y, GlyphString glyphs)` This is a low-level function.
`void` `drawGrayImage(GC gc, int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride)`
`void` `drawGrayImage(int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride)`
`void` `drawImage(GC gc, Image image, int xsrc, int ysrc, int xdest, int ydest, int width, int height)` Draw an Image onto this Drawable.
`void` `drawImage(Image image, int xsrc, int ysrc, int xdest, int ydest, int width, int height)` Draw an Image onto this Drawable using the default GC.
`void` `drawIndexedImage(GC gc, int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride, RgbCmap cmap)`
`void` `drawIndexedImage(int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride, RgbCmap cmap)`
`void` `drawLayout(GC gc, int x, int y, Layout layout)` Render a Layout onto this Drawable.
`void` `drawLayout(int x, int y, Layout layout)` Render a Layout onto this Drawable using the default GC.
`void` `drawLayoutLine(GC gc, int x, int y, LayoutLine line)` Render a LayoutLine onto this Drawable.
`void` `drawLayoutLine(int x, int y, LayoutLine line)` Render a LayoutLine onto this Drawable using the default GC.
`void` `drawLayoutLineWithColors(GC gc, int x, int y, LayoutLine line, Color foreground, Color background)` Render a LayoutLne onto this Drawable overriding the layout's normal colors with the provided forground and background.
`void` `drawLayoutLineWithColors(int x, int y, LayoutLine line, Color foreground, Color background)` Render a LayoutLne onto this Drawable overriding the layout's normal colors with the provided forground and background and using the default GC.
`void` `drawLayoutWithColors(GC gc, int x, int y, Layout layout, Color foreground, Color background)` Render a Layout onto this Drawable overriding the layout's normal colors with the provided forground and background.
`void` `drawLayoutWithColors(int x, int y, Layout layout, Color foreground, Color background)` Render a Layout onto this Drawable overriding the layout's normal colors with the provided forground and background using the default GC.
`void` `drawLine(GC gc, int x1, int y1, int x2, int y2)` Draw a line using the foreground color and other attributes of the GC.
`void` `drawLine(int x1, int y1, int x2, int y2)` Draw a line using the foreground color and other attributes of the default GC.
`void` `drawLines(GC gc, Point[] points)` Draw a series of lines connecting the given points.
`void` `drawLines(Point[] points)` Draw a series of lines connecting the given points.
`void` `drawPixbuf(GC gc, Pixbuf pixbuf, int srcx, int srcy, int destx, int desty, int width, int height, RgbDither dither, int xdither, int ydither)` Render a rectangular portion of a Pixbuf to this Drawable.
`void` `drawPixbuf(Pixbuf pixbuf, int srcx, int srcy, int destx, int desty, int width, int height, RgbDither dither, int xdither, int ydither)` Render a rectangular portion of a Pixbuf to this Drawable.
`void` `drawPoint(GC gc, int x, int y)` Draw a point using the foreground color and other attributes of the GC.
`void` `drawPoint(int x, int y)` Draw a point using the foreground color and other attributes of the default GC.
`void` `drawPoints(GC gc, Point[] points)` Draw a number of points using the forground color and other attributes of the GC.
`void` `drawPoints(Point[] points)` Draw a number of points using the forground color and other attributes of the default GC.
`void` `drawPolygon(boolean filled, Point[] points)` Convience method that draws an outlined or filled polygon using the default GC.
`void` `drawPolygon(GC gc, boolean filled, Point[] points)` Draws an outlined or filled polygon.
`void` `drawRectangle(boolean filled, int x, int y, int width, int height)` Draws a rectangle outlined or filled using the forground color and other attributes of the default GC.
`void` `drawRectangle(GC gc, boolean filled, int x, int y, int width, int height)` Draws a rectangle outlined or filled using the forground color and other attributes of the GC.
`void` `drawRGB32Image(GC gc, int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride)`
`void` `drawRGB32Image(int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride)`
`void` `drawRGB32ImageDitherAlign(GC gc, int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride, int xdith, int ydith)`
`void` `drawRGB32ImageDitherAlign(int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride, int xdith, int ydith)`
`void` `drawRGBImage(GC gc, int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride)`
`void` `drawRGBImage(int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride)`
`void` `drawRGBImageDitherAlign(GC gc, int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride, int xdith, int ydith)`
`void` `drawRGBImageDitherAlign(int x, int y, int width, int height, RgbDither dither, byte[] buffer, int rowStride, int xdith, int ydith)`
`void` `drawSegments(GC gc, Segment[] segments)` Draw a number of unconnected lines.
`void` `drawSegments(Segment[] segments)` Draw a number of unconnected lines using the default GC.
`protected static void` `gdk_draw_arc(Handle drawable, Handle gc, boolean filled, int x, int y, int width, int height, int angle1, int angle2)`
`protected static void` `gdk_draw_drawable(Handle drawable, Handle gc, Handle src, int xsrc, int ysrc, int xdest, int ydest, int width, int height)`
`protected static void` `gdk_draw_glyphs(Handle drawable, Handle gc, Handle font, int x, int y, Handle glyphs)`
`protected static void` `gdk_draw_gray_image(Handle drawable, Handle gc, int x, int y, int width, int height, int dith, byte[] rgbBuf, int rowstride)`
`protected static void` `gdk_draw_image(Handle drawable, Handle gc, Handle image, int xsrc, int ysrc, int xdest, int ydest, int width, int height)`
`protected static void` `gdk_draw_indexed_image(Handle drawable, Handle gc, int x, int y, int width, int height, int dith, byte[] buf, int rowstride, Handle cmap)`
`protected static void` `gdk_draw_layout_line_with_colors(Handle drawable, Handle gc, int x, int y, Handle line, Handle foreground, Handle background)`
`protected static void` `gdk_draw_layout_line(Handle drawable, Handle gc, int x, int y, Handle line)`
`protected static void` `gdk_draw_layout_with_colors(Handle drawable, Handle gc, int x, int y, Handle layout, Handle foreground, Handle background)`
`protected static void` `gdk_draw_layout(Handle drawable, Handle gc, int x, int y, Handle layout)`
`protected static void` `gdk_draw_line(Handle drawable, Handle gc, int x1, int y1, int x2, int y2)`
`protected static void` `gdk_draw_lines(Handle drawable, Handle gc, Handle[] points)`
`protected static void` `gdk_draw_pixbuf(Handle drawable, Handle gc, Handle pixbuf, int srcx, int srcy, int destx, int desty, int width, int height, int dither, int xdith, int ydith)`
`protected static void` `gdk_draw_point(Handle drawable, Handle gc, int x, int y)`
`protected static void` `gdk_draw_points(Handle drawable, Handle gc, Handle[] points)`
`protected static void` `gdk_draw_polygon(Handle drawable, Handle gc, boolean filled, Handle[] points)`
`protected static void` `gdk_draw_rectangle(Handle drawable, Handle gc, boolean filled, int x, int y, int width, int height)`
`protected static void` `gdk_draw_rgb_32_image_dithalign(Handle drawable, Handle gc, int x, int y, int width, int height, int dith, byte[] rgbBuf, int rowstride, int xDith, int yDith)`
`protected static void` `gdk_draw_rgb_32_image(Handle drawable, Handle gc, int x, int y, int width, int height, int dith, byte[] rgbBuf, int rowstride)`
`protected static void` `gdk_draw_rgb_image_dithalign(Handle drawable, Handle gc, int x, int y, int width, int height, int dith, byte[] rgbBuf, int rowstride, int xDith, int yDith)`
`protected static void` `gdk_draw_rgb_image(Handle drawable, Handle gc, int x, int y, int width, int height, int dith, byte[] rgbBuf, int rowstride)`
`protected static void` `gdk_draw_segments(Handle drawable, Handle gc, Handle[] segments)`
`protected static Handle` `gdk_drawable_get_clip_region(Handle drawable)`
`protected static Handle` `gdk_drawable_get_colormap(Handle drawable)`
`protected static int` `gdk_drawable_get_depth(Handle drawable)`
`protected static Handle` `gdk_drawable_get_display(Handle drawable)`
`protected static Handle` `gdk_drawable_get_image(Handle drawable, int x, int y, int width, int height)`
`protected static Handle` `gdk_drawable_get_screen(Handle drawable)`
`protected static void` `gdk_drawable_get_size(Handle drawable, int[] width, int[] height)`
`protected static int` `gdk_drawable_get_type()`
`protected static Handle` `gdk_drawable_get_visible_region(Handle drawable)`
`protected static Handle` `gdk_drawable_get_visual(Handle drawable)`
`protected static void` `gdk_drawable_set_colormap(Handle drawable, Handle colormap)`
`Region` `getClipRegion()` Computes the Region of a Drawable that potentially can be written to by drawing primitives.
`Colormap` `getColormap()` Gets the Colormap for the Drawable if one is set; returns null otherwise.
`int` `getDepth()` Obtains the bit depth of the Drawable, this is, the number of bits that make up a pixel.
`Display` `getDisplay()` Get the Display associated with the Drawable.
`Image` `getImage(int x, int y, int width, int height)` Obtains the pixels from a server-side Drawable as a client-side Image.
`Screen` `getScreen()` Get the Screen associated with the Drawable.
`Dimension` `getSize()` Returns the size of the Drawable.
`static Type` `getType()` Retrieve the runtime type used by the GLib library.
`Region` `getVisibleRegion()` Computes the Region of a Drawable that is potentially visible.
`Visual` `getVisual()` Gets the Visual describing the pixel format of this Drawable.
`void` `setColormap(Colormap cmap)` Sets the Colormap associated with the Drawable.

Methods inherited from class org.gnu.glib.GObject

`addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addEventHandler, addListener, equals, freezeNotify, getBooleanProperty, getData, getData, getDoubleProperty, getEventListenerClass, getEventType, getFloatProperty, getGObjectFromHandle, getHandle, getIntFromHandle, getIntProperty, getJavaObjectProperty, getLongProperty, getNullHandle, getPixbufProperty, getProperty, getStringFromHandle, getStringProperty, hashCode, hasProperty, instantiateJGObjectFromGType, notify, removeEventHandler, removeListener, retrieveGObject, setBooleanProperty, setData, setData, setDoubleProperty, setFloatProperty, setHandle, setIntProperty, setJavaObjectProperty, setLongProperty, setPixbufProperty, setProperty, setStringProperty, thawNotify`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### Drawable

    public Drawable(Handle handle)

Method Detail

### getSize

    public Dimension getSize()

  Returns the size of the Drawable.

### setColormap

    public void setColormap(Colormap cmap)

  Sets the Colormap associated with the Drawable. Normally this happens automatically when the Drawable is created.

  Parameters:
    `cmap` -

### getColormap

    public Colormap getColormap()

  Gets the Colormap for the Drawable if one is set; returns null otherwise.

### getVisual

    public Visual getVisual()

  Gets the Visual describing the pixel format of this Drawable.

### getDepth

    public int getDepth()

  Obtains the bit depth of the Drawable, this is, the number of bits that make up a pixel.

### getImage

    public Image getImage(int x,
                          int y,
                          int width,
                          int height)

  Obtains the pixels from a server-side Drawable as a client-side Image. The format of the Image depends on the Visual for the current display which makes manipulating Image extremely difficult.

  Parameters:
    `x` -
    `y` -
    `width` -
    `height` -

### getClipRegion

    public Region getClipRegion()

  Computes the Region of a Drawable that potentially can be written to by drawing primitives. This Region will not take into account the clip region for the GC, and may also not take into account other factors such as if the Window is obscured by other Windows.

### getVisibleRegion

    public Region getVisibleRegion()

  Computes the Region of a Drawable that is potentially visible.

### drawRGBImage

    public void drawRGBImage(GC gc,
                             int x,
                             int y,
                             int width,
                             int height,
                             RgbDither dither,
                             byte[] buffer,
                             int rowStride)

### drawRGBImage

    public void drawRGBImage(int x,
                             int y,
                             int width,
                             int height,
                             RgbDither dither,
                             byte[] buffer,
                             int rowStride)

### drawRGBImageDitherAlign

    public void drawRGBImageDitherAlign(GC gc,
                                        int x,
                                        int y,
                                        int width,
                                        int height,
                                        RgbDither dither,
                                        byte[] buffer,
                                        int rowStride,
                                        int xdith,
                                        int ydith)

### drawRGBImageDitherAlign

    public void drawRGBImageDitherAlign(int x,
                                        int y,
                                        int width,
                                        int height,
                                        RgbDither dither,
                                        byte[] buffer,
                                        int rowStride,
                                        int xdith,
                                        int ydith)

### drawRGB32Image

    public void drawRGB32Image(GC gc,
                               int x,
                               int y,
                               int width,
                               int height,
                               RgbDither dither,
                               byte[] buffer,
                               int rowStride)

### drawRGB32Image

    public void drawRGB32Image(int x,
                               int y,
                               int width,
                               int height,
                               RgbDither dither,
                               byte[] buffer,
                               int rowStride)

### drawRGB32ImageDitherAlign

    public void drawRGB32ImageDitherAlign(GC gc,
                                          int x,
                                          int y,
                                          int width,
                                          int height,
                                          RgbDither dither,
                                          byte[] buffer,
                                          int rowStride,
                                          int xdith,
                                          int ydith)

### drawRGB32ImageDitherAlign

    public void drawRGB32ImageDitherAlign(int x,
                                          int y,
                                          int width,
                                          int height,
                                          RgbDither dither,
                                          byte[] buffer,
                                          int rowStride,
                                          int xdith,
                                          int ydith)

### drawGrayImage

    public void drawGrayImage(GC gc,
                              int x,
                              int y,
                              int width,
                              int height,
                              RgbDither dither,
                              byte[] buffer,
                              int rowStride)

### drawGrayImage

    public void drawGrayImage(int x,
                              int y,
                              int width,
                              int height,
                              RgbDither dither,
                              byte[] buffer,
                              int rowStride)

### drawIndexedImage

    public void drawIndexedImage(GC gc,
                                 int x,
                                 int y,
                                 int width,
                                 int height,
                                 RgbDither dither,
                                 byte[] buffer,
                                 int rowStride,
                                 RgbCmap cmap)

### drawIndexedImage

    public void drawIndexedImage(int x,
                                 int y,
                                 int width,
                                 int height,
                                 RgbDither dither,
                                 byte[] buffer,
                                 int rowStride,
                                 RgbCmap cmap)

### drawPolygon

    public void drawPolygon(GC gc,
                            boolean filled,
                            Point[] points)

  Draws an outlined or filled polygon.

  Parameters:
    `gc` -
    `filled` -
    `points` -

### drawPolygon

    public void drawPolygon(boolean filled,
                            Point[] points)

  Convience method that draws an outlined or filled polygon using the default GC.

  Parameters:
    `filled` -
    `points` -

### drawDrawable

    public void drawDrawable(GC gc,
                             Drawable src,
                             int xsrc,
                             int ysrc,
                             int xdest,
                             int ydest,
                             int width,
                             int height)

  Copies the width x height region of the Drawable at coordinates (xsrc,ysrc) to coordinates (xdest,ydest).

  Parameters:
    `gc` -
    `src` -
    `xsrc` -
    `ysrc` -
    `xdest` -
    `ydest` -
    `width` -
    `height` -

### drawDrawable

    public void drawDrawable(Drawable src,
                             int xsrc,
                             int ysrc,
                             int xdest,
                             int ydest,
                             int width,
                             int height)

  Convience method that copies the width x height region of the Drawable at coordinates (xsrc,ysrc) to coordinates (xdest,ydest) using the default GC.

  Parameters:
    `src` -
    `xsrc` -
    `ysrc` -
    `xdest` -
    `ydest` -
    `width` -
    `height` -

### drawImage

    public void drawImage(GC gc,
                          Image image,
                          int xsrc,
                          int ysrc,
                          int xdest,
                          int ydest,
                          int width,
                          int height)

  Draw an Image onto this Drawable. The depth of the Image must match the depth of this Drawable.

  Parameters:
    `gc` -
    `image` -
    `xsrc` -
    `ysrc` -
    `xdest` -
    `ydest` -
    `width` -
    `height` -

### drawImage

    public void drawImage(Image image,
                          int xsrc,
                          int ysrc,
                          int xdest,
                          int ydest,
                          int width,
                          int height)

  Draw an Image onto this Drawable using the default GC. The depth of the Image must match the depth of this Drawable.

  Parameters:
    `image` -
    `xsrc` -
    `ysrc` -
    `xdest` -
    `ydest` -
    `width` -
    `height` -

### drawPoints

    public void drawPoints(GC gc,
                           Point[] points)

  Draw a number of points using the forground color and other attributes of the GC.

  Parameters:
    `gc` -
    `points` -

### drawPoints

    public void drawPoints(Point[] points)

  Draw a number of points using the forground color and other attributes of the default GC.

  Parameters:
    `points` -

### drawSegments

    public void drawSegments(GC gc,
                             Segment[] segments)

  Draw a number of unconnected lines.

  Parameters:
    `gc` -
    `segments` -

### drawSegments

    public void drawSegments(Segment[] segments)

  Draw a number of unconnected lines using the default GC.

  Parameters:
    `segments` -

### drawLines

    public void drawLines(GC gc,
                          Point[] points)

  Draw a series of lines connecting the given points. The way in which joins between lines are drawn is determined by the CapStyle value in GC.

  Parameters:
    `gc` -
    `points` -

### drawLines

    public void drawLines(Point[] points)

  Draw a series of lines connecting the given points. The way in which joins between lines are drawn is determined by the CapStyle value in the default GC.

  Parameters:
    `points` -

### drawGlyphs

    public void drawGlyphs(GC gc,
                           Font font,
                           int x,
                           int y,
                           GlyphString glyphs)

  This is a low-level function. Normally, 99 percent of text rendering should be down using drawLayout() instead.

  A glyph is a single image in a font. This method draws a sequence of glyphs.

  Parameters:
    `gc` -
    `font` -
    `x` -
    `y` -
    `glyphs` -

### drawGlyphs

    public void drawGlyphs(Font font,
                           int x,
                           int y,
                           GlyphString glyphs)

  This is a low-level function. Normally, 99 percent of text rendering should be down using drawLayout() instead.

  A glyph is a single image in a font. This method draws a sequence of glyphs.

  Parameters:
    `font` -
    `x` -
    `y` -
    `glyphs` -

### drawLayoutLine

    public void drawLayoutLine(GC gc,
                               int x,
                               int y,
                               LayoutLine line)

  Render a LayoutLine onto this Drawable.

  Parameters:
    `gc` -
    `x` -
    `y` -
    `line` -

### drawLayoutLine

    public void drawLayoutLine(int x,
                               int y,
                               LayoutLine line)

  Render a LayoutLine onto this Drawable using the default GC.

  Parameters:
    `x` -
    `y` -
    `line` -

### drawLayout

    public void drawLayout(GC gc,
                           int x,
                           int y,
                           Layout layout)

  Render a Layout onto this Drawable.

  Parameters:
    `gc` -
    `x` -
    `y` -
    `layout` -

### drawLayout

    public void drawLayout(int x,
                           int y,
                           Layout layout)

  Render a Layout onto this Drawable using the default GC.

  Parameters:
    `x` -
    `y` -
    `layout` -

### drawLayoutLineWithColors

    public void drawLayoutLineWithColors(GC gc,
                                         int x,
                                         int y,
                                         LayoutLine line,
                                         Color foreground,
                                         Color background)

  Render a LayoutLne onto this Drawable overriding the layout's normal colors with the provided forground and background.

  Parameters:
    `gc` -
    `x` -
    `y` -
    `line` -
    `foreground` -
    `background` -

### drawLayoutLineWithColors

    public void drawLayoutLineWithColors(int x,
                                         int y,
                                         LayoutLine line,
                                         Color foreground,
                                         Color background)

  Render a LayoutLne onto this Drawable overriding the layout's normal colors with the provided forground and background and using the default GC.

  Parameters:
    `x` -
    `y` -
    `line` -
    `foreground` -
    `background` -

### drawLayoutWithColors

    public void drawLayoutWithColors(GC gc,
                                     int x,
                                     int y,
                                     Layout layout,
                                     Color foreground,
                                     Color background)

  Render a Layout onto this Drawable overriding the layout's normal colors with the provided forground and background.

  Parameters:
    `gc` -
    `x` -
    `y` -
    `layout` -
    `foreground` -
    `background` -

### drawLayoutWithColors

    public void drawLayoutWithColors(int x,
                                     int y,
                                     Layout layout,
                                     Color foreground,
                                     Color background)

  Render a Layout onto this Drawable overriding the layout's normal colors with the provided forground and background using the default GC.

  Parameters:
    `x` -
    `y` -
    `layout` -
    `foreground` -
    `background` -

### getDisplay

    public Display getDisplay()

  Get the Display associated with the Drawable.

### getScreen

    public Screen getScreen()

  Get the Screen associated with the Drawable.

### drawPoint

    public void drawPoint(GC gc,
                          int x,
                          int y)

  Draw a point using the foreground color and other attributes of the GC.

  Parameters:
    `gc` -
    `x` -
    `y` -

### drawPoint

    public void drawPoint(int x,
                          int y)

  Draw a point using the foreground color and other attributes of the default GC.

  Parameters:
    `x` -
    `y` -

### drawLine

    public void drawLine(GC gc,
                         int x1,
                         int y1,
                         int x2,
                         int y2)

  Draw a line using the foreground color and other attributes of the GC.

  Parameters:
    `gc` -
    `x1` -
    `y1` -
    `x2` -
    `y2` -

### drawLine

    public void drawLine(int x1,
                         int y1,
                         int x2,
                         int y2)

  Draw a line using the foreground color and other attributes of the default GC.

  Parameters:
    `x1` -
    `y1` -
    `x2` -
    `y2` -

### drawPixbuf

    public void drawPixbuf(GC gc,
                           Pixbuf pixbuf,
                           int srcx,
                           int srcy,
                           int destx,
                           int desty,
                           int width,
                           int height,
                           RgbDither dither,
                           int xdither,
                           int ydither)

  Render a rectangular portion of a Pixbuf to this Drawable.

  Parameters:
    `gc` -
    `pixbuf` -
    `srcx` -
    `srcy` -
    `destx` -
    `desty` -
    `width` -
    `height` -
    `dither` -
    `xdither` -
    `ydither` -

### drawPixbuf

    public void drawPixbuf(Pixbuf pixbuf,
                           int srcx,
                           int srcy,
                           int destx,
                           int desty,
                           int width,
                           int height,
                           RgbDither dither,
                           int xdither,
                           int ydither)

  Render a rectangular portion of a Pixbuf to this Drawable.

  Parameters:
    `pixbuf` -
    `srcx` -
    `srcy` -
    `destx` -
    `desty` -
    `width` -
    `height` -
    `dither` -
    `xdither` -
    `ydither` -

### drawRectangle

    public void drawRectangle(GC gc,
                              boolean filled,
                              int x,
                              int y,
                              int width,
                              int height)

  Draws a rectangle outlined or filled using the forground color and other attributes of the GC.

  Parameters:
    `gc` -
    `filled` -
    `x` -
    `y` -
    `width` -
    `height` -

### drawRectangle

    public void drawRectangle(boolean filled,
                              int x,
                              int y,
                              int width,
                              int height)

  Draws a rectangle outlined or filled using the forground color and other attributes of the default GC.

  Parameters:
    `filled` -
    `x` -
    `y` -
    `width` -
    `height` -

### drawArc

    public void drawArc(GC gc,
                        boolean filled,
                        int x,
                        int y,
                        int width,
                        int height,
                        int angle1,
                        int angle2)

  Draws an arc or a filled 'pie slice'. The arc is defined by the bounding rectangle of the entire elipse, and the start and end angles of the part of the elipse to be drawn.

  Parameters:
    `gc` -
    `filled` -
    `x` -
    `y` -
    `width` -
    `height` -
    `angle1` -
    `angle2` -

### drawArc

    public void drawArc(boolean filled,
                        int x,
                        int y,
                        int width,
                        int height,
                        int angle1,
                        int angle2)

  Draws an arc or a filled 'pie slice'. The arc is defined by the bounding rectangle of the entire elipse, and the start and end angles of the part of the elipse to be drawn.

  Parameters:
    `filled` -
    `x` -
    `y` -
    `width` -
    `height` -
    `angle1` -
    `angle2` -

### getType

    public static Type getType()

  Retrieve the runtime type used by the GLib library.

### gdk_drawable_get_type

    protected static final int gdk_drawable_get_type()

### gdk_drawable_get_display

    protected static final Handle gdk_drawable_get_display(Handle drawable)

### gdk_drawable_get_screen

    protected static final Handle gdk_drawable_get_screen(Handle drawable)

### gdk_drawable_get_visual

    protected static final Handle gdk_drawable_get_visual(Handle drawable)

### gdk_drawable_set_colormap

    protected static final void gdk_drawable_set_colormap(Handle drawable,
                                                          Handle colormap)

### gdk_drawable_get_colormap

    protected static final Handle gdk_drawable_get_colormap(Handle drawable)

### gdk_drawable_get_depth

    protected static final int gdk_drawable_get_depth(Handle drawable)

### gdk_drawable_get_size

    protected static final void gdk_drawable_get_size(Handle drawable,
                                                      int[] width,
                                                      int[] height)

### gdk_drawable_get_clip_region

    protected static final Handle gdk_drawable_get_clip_region(Handle drawable)

### gdk_drawable_get_visible_region

    protected static final Handle gdk_drawable_get_visible_region(Handle drawable)

### gdk_drawable_get_image

    protected static final Handle gdk_drawable_get_image(Handle drawable,
                                                         int x,
                                                         int y,
                                                         int width,
                                                         int height)

### gdk_draw_point

    protected static final void gdk_draw_point(Handle drawable,
                                               Handle gc,
                                               int x,
                                               int y)

### gdk_draw_points

    protected static final void gdk_draw_points(Handle drawable,
                                                Handle gc,
                                                Handle[] points)

### gdk_draw_line

    protected static final void gdk_draw_line(Handle drawable,
                                              Handle gc,
                                              int x1,
                                              int y1,
                                              int x2,
                                              int y2)

### gdk_draw_lines

    protected static final void gdk_draw_lines(Handle drawable,
                                               Handle gc,
                                               Handle[] points)

### gdk_draw_pixbuf

    protected static final void gdk_draw_pixbuf(Handle drawable,
                                                Handle gc,
                                                Handle pixbuf,
                                                int srcx,
                                                int srcy,
                                                int destx,
                                                int desty,
                                                int width,
                                                int height,
                                                int dither,
                                                int xdith,
                                                int ydith)

### gdk_draw_segments

    protected static final void gdk_draw_segments(Handle drawable,
                                                  Handle gc,
                                                  Handle[] segments)

### gdk_draw_rectangle

    protected static final void gdk_draw_rectangle(Handle drawable,
                                                   Handle gc,
                                                   boolean filled,
                                                   int x,
                                                   int y,
                                                   int width,
                                                   int height)

### gdk_draw_arc

    protected static final void gdk_draw_arc(Handle drawable,
                                             Handle gc,
                                             boolean filled,
                                             int x,
                                             int y,
                                             int width,
                                             int height,
                                             int angle1,
                                             int angle2)

### gdk_draw_polygon

    protected static final void gdk_draw_polygon(Handle drawable,
                                                 Handle gc,
                                                 boolean filled,
                                                 Handle[] points)

### gdk_draw_glyphs

    protected static final void gdk_draw_glyphs(Handle drawable,
                                                Handle gc,
                                                Handle font,
                                                int x,
                                                int y,
                                                Handle glyphs)

### gdk_draw_layout_line

    protected static final void gdk_draw_layout_line(Handle drawable,
                                                     Handle gc,
                                                     int x,
                                                     int y,
                                                     Handle line)

### gdk_draw_layout_line_with_colors

    protected static final void gdk_draw_layout_line_with_colors(Handle drawable,
                                                                 Handle gc,
                                                                 int x,
                                                                 int y,
                                                                 Handle line,
                                                                 Handle foreground,
                                                                 Handle background)

### gdk_draw_layout

    protected static final void gdk_draw_layout(Handle drawable,
                                                Handle gc,
                                                int x,
                                                int y,
                                                Handle layout)

### gdk_draw_layout_with_colors

    protected static final void gdk_draw_layout_with_colors(Handle drawable,
                                                            Handle gc,
                                                            int x,
                                                            int y,
                                                            Handle layout,
                                                            Handle foreground,
                                                            Handle background)

### gdk_draw_drawable

    protected static final void gdk_draw_drawable(Handle drawable,
                                                  Handle gc,
                                                  Handle src,
                                                  int xsrc,
                                                  int ysrc,
                                                  int xdest,
                                                  int ydest,
                                                  int width,
                                                  int height)

### gdk_draw_image

    protected static final void gdk_draw_image(Handle drawable,
                                               Handle gc,
                                               Handle image,
                                               int xsrc,
                                               int ysrc,
                                               int xdest,
                                               int ydest,
                                               int width,
                                               int height)

### gdk_draw_rgb_image

    protected static final void gdk_draw_rgb_image(Handle drawable,
                                                   Handle gc,
                                                   int x,
                                                   int y,
                                                   int width,
                                                   int height,
                                                   int dith,
                                                   byte[] rgbBuf,
                                                   int rowstride)

### gdk_draw_rgb_image_dithalign

    protected static final void gdk_draw_rgb_image_dithalign(Handle drawable,
                                                             Handle gc,
                                                             int x,
                                                             int y,
                                                             int width,
                                                             int height,
                                                             int dith,
                                                             byte[] rgbBuf,
                                                             int rowstride,
                                                             int xDith,
                                                             int yDith)

### gdk_draw_rgb_32_image

    protected static final void gdk_draw_rgb_32_image(Handle drawable,
                                                      Handle gc,
                                                      int x,
                                                      int y,
                                                      int width,
                                                      int height,
                                                      int dith,
                                                      byte[] rgbBuf,
                                                      int rowstride)

### gdk_draw_rgb_32_image_dithalign

    protected static final void gdk_draw_rgb_32_image_dithalign(Handle drawable,
                                                                Handle gc,
                                                                int x,
                                                                int y,
                                                                int width,
                                                                int height,
                                                                int dith,
                                                                byte[] rgbBuf,
                                                                int rowstride,
                                                                int xDith,
                                                                int yDith)

### gdk_draw_gray_image

    protected static final void gdk_draw_gray_image(Handle drawable,
                                                    Handle gc,
                                                    int x,
                                                    int y,
                                                    int width,
                                                    int height,
                                                    int dith,
                                                    byte[] rgbBuf,
                                                    int rowstride)

### gdk_draw_indexed_image

    protected static final void gdk_draw_indexed_image(Handle drawable,
                                                       Handle gc,
                                                       int x,
                                                       int y,
                                                       int width,
                                                       int height,
                                                       int dith,
                                                       byte[] buf,
                                                       int rowstride,
                                                       Handle cmap)